<template>
  <dashboard-layout title="Configuration">
    <div class="col-sm-12 mx-auto" >
      <div>
        <h3><i class="fa fa-cog"></i> Configuration du restaurant</h3>
      </div>
      <div class="container mx-auto">
        <div class="row">
          <div class="col-sm-6 mx-auto">
            <form class="pt-3">
              <fieldset>
                <form @submit="configservice" class="mt-4">
                  <div class="form-group">
                    <input type="text" class="form-control" v-model="service.name" required placeholder="Le nom du service">
                  </div>
                  <div class="form-group">
                    <textarea class="form-control" v-model="service.description" required placeholder="Une description du service" cols="20" rows="5"></textarea>
                  </div>
                  <div class="form-group">
                    <input type="text" class="form-control" v-model="service.contact" required placeholder="Le contact du service">
                  </div>
              <!-- 
                  <div class="form-group">
                    <label for="">Logo</label>
                    <input type="file" id="file" ref="myFiles" class="form-control" name="logo" required @change="previewFiles">
                  </div>
                  <div class="form-group">
                    <label for="">Cover</label>
                    <input type="file" class="form-control" name="cover" required >
                  </div>
              -->
                  <div v-if="state" class="form-group text-right">
                    <input type="submit" class="btn btn-default btn-manote" value="Modifier">
                  </div>
                  <div v-else class="form-group text-right">
                    <input type="submit" class="btn btn-default btn-manote" value="Suivant">
                  </div>
                </form>
              </fieldset>
            </form>
          </div>
          
          <div v-if="service && service.qrcode" class="col-sm-4 mx-auto pt-3">
            <div class="card mx-auto mt-4">
              <div class="card-body ">
                <img :src="service.qrcode" class="img-fluid w-100"/>
              </div>
            </div>
            <div class="mt-4 mx-auto">
              <span class="btn btn-default btn-manote pull-left">Exporter en PDF</span>
              <span class="btn btn-default btn-manote pull-right">Imprimer</span>
            </div>
          </div>
        </div>
      </div>
    </div>
  </dashboard-layout>
</template>

<script>
//e.target.files[0]
export default {
  name: 'ConfigService',
  data () {
    return {
      service: {
        name: '',
        description: '',
        qrcode: '',
        //logo: '',
        //cover: '',
        userId: '',
        contact: '',
        id: ''
      },
      errorMessage: '',
      serviceId: '',
      state: false
    }
  },
  mounted() {
    const serviceId = localStorage.getItem('serviceId');
    const userId = localStorage.getItem('userId');

    if(!serviceId) {
      this.$service.getServiceByUser({userId},(err, data) => {
        if (err) {
          this.errorMessage = err.data;
          return;
        }

        if (data && data.services) {
          const service = data.services[0] || {};

          if (service._id) {
            this.state = true;
            localStorage.setItem('serviceId', service._id);
            
            this.service.name = service.name;
            this.service.description = service.description;
            this.service.contact = service.contact; 
            this.service.qrcode = service.qrcode; 
          }
        }
      });
    } else {
      this.state = true;
      this.$service.getServiceById(serviceId,(err, data) => {
        if (err) {
          this.errorMessage = err.data;
          return;
        }

        console.log('serv', data);

        if (data && data.service) {
          const service = data.service || {};

          if (service._id) {
            this.state = true;
          }
        
          localStorage.setItem('serviceId', service._id);
        
          this.service.name = service.name;
          this.service.description = service.description;
          this.service.contact = service.contact; 
          this.service.qrcode = service.qrcode; 
        }
      });
    }
  },
  methods: {
    /*
    previewFiles(){
      this.service.logo = this.$refs.myFiles.files
    },*/
    configservice (e) {
      e.preventDefault();
  
      const serviceId = localStorage.getItem('serviceId');

      if (serviceId) {
        this.service.id = serviceId;
        
        this.$service.configserviceUpdate(this.service, (err, data) => {
          if (err) {
            this.errorMessage = err.data;
            console.log('Error', err.data);
            return;
          }

          this.service.name = data.service.name;
          this.service.description = data.service.description;
          this.service.contact = data.service.contact; 
          this.service.qrcode = data.service.qrcode; 
        });

      } else {
        //traitemeent en cas de nouveau service
        this.service.userId = localStorage.getItem('userId');

        this.$service.configserviceCreate(this.service, (err, data) => {
          if (err) {
            this.errorMessage = err.data;
            console.log('Error', err.data);
            return;
          }

          this.service.name = data.service.name;
          this.service.description = data.service.description;
          this.service.contact = data.service.contact; 
          this.service.qrcode = data.service.qrcode; 
          this.state = true;
        });
      }
    }
  }
}
</script>